require('scripts/element_floor')
require('scripts/element_anthem_tick')
require('scripts/scene_rain')
require('scripts/scene_burst_1')
require('scripts/scene_toobs')
require('scripts/scene_burst_hook')
require('scripts/scene_roads')
require('scripts/scene_rain_anthem')

require('scripts/scene_rain_road')

math.randomseed(32452)


music("StarWindow.mp3")

scenes = {
  {startTime = 0, init = scene_rain_init, frame = scene_rain_frame, finish = scene_rain_finish},
  {startTime = 32, init = scene_burst_1_init, frame = scene_burst_1_frame, finish = scene_burst_1_finish},
  {startTime = 64, init = scene_toobs_init, frame = scene_toobs_frame, finish = scene_toobs_finish},
  {startTime = 96, init = scene_burst_hook_init, frame = scene_burst_hook_frame, finish = scene_burst_hook_finish},
  {startTime = 128, init = scene_roads_init, frame = scene_roads_frame, finish = scene_roads_finish},
  {startTime = 160, init = scene_rain_road_init, frame = scene_rain_road_frame, finish = scene_rain_road_finish},
  {startTime = 224, init = scene_rain_anthem_init, frame = scene_rain_anthem_frame, finish = scene_rain_anthem_finish}
}
scene_id = 1

scenes[scene_id]["init"]()

function frame(frames)
  time_beats = 90 * frames / (44100 * 60)
  if #scenes > scene_id and scenes[scene_id+1]["startTime"] <= time_beats then
    scenes[scene_id]["finish"]()
    scene_id = scene_id + 1
    scenes[scene_id]["init"]()
  end
  scenes[scene_id]["frame"](time_beats-scenes[scene_id]["startTime"])
end
